#!/usr/bin/env python
import re

def nodesCollectFromNewick(treeFN):

    nodes = []     # 2D array for nodes
    cladeReg = "\(([^\(\)]+)\)(\d+)"
    while re.search(cladeReg, treeFN):
        treeFN = treeFN.rstrip("\n")
        match = re.search(cladeReg, treeFN)               # Pick up the smallest and leftmost clade for the following analysis
        leavesString = match.group(1)
        exp          = match.group(2)
        leaves = set(leavesString.split(","))
        leaves2 = [re.sub(":.+", "", leaf) for leaf in leaves]  # Delete branch lengths
        treeFN = re.sub(cladeReg, r"\1", treeFN, 1)            # Delete the outer parentheses from the analyzed clade
        nodes.append([len(leaves2), leaves2, exp])

    sortedNodes = sorted(nodes, key=lambda x:x[0], reverse=True)

    ## Add leaves as nodes
    largestNode = sortedNodes[0];
    for leaf in largestNode[1]:
        exp = 100
        tempLeafNode = {leaf}
        sortedNodes.append([1, tempLeafNode, exp])

    return sortedNodes


t = open("tree11spp.txt")
#t = open("tree108spp.txt")
tree = list(t)[0]
t.close()

allNodes = nodesCollectFromNewick(tree)
print("tree:", tree)
count = 0
for leaf in allNodes[0][1]:
    count += 1
    print(count, ":", leaf)

